#include    "main.h"
#include    "goto.h"

u8 t[151]={178, 145, 121, 103, 88, 76, 67, 59, 52, 47,
			42, 38, 35, 32, 29, 27, 25, 23, 21, 20,
			18, 17, 16, 15, 14, 13, 13, 12, 11, 11,
			10, 10, 9, 9, 8, 8, 8, 7, 7, 7,
			7, 6, 6, 6, 6, 5, 5, 5, 5, 5,
			5, 4, 4, 4, 4, 4, 4, 4, 4, 3,
			3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
			3, 2, 2, 2, 2, 2, 2, 2, 2, 2,
			2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
			2, 2, 2, 2, 1, 1, 1, 1, 1, 1,
			1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
			1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
			1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
			1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
			1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};

void initEQDRIVE (struct RegisterAxis *ra, struct RegisterAxis *dec){
	
	ra->K1  = (9024000/100) / (float)RA_TOTAL_STEPS; //     c() EQMOD
	dec->K1 = (9024000/100) / (float)RA_TOTAL_STEPS;
	
	ra->K2  = (2.31*9024000) / (float)RA_TOTAL_STEPS;
	dec->K2 = (2.31*9024000) / (float)RA_TOTAL_STEPS;
	
	ra->BeginBraking  = (u32)(25000 / ra->K1);
	dec->BeginBraking = (u32)(25000 / dec->K1);
	
	ra->GotoBegin800x  = (u32)(0xFFFF / ra->K1);
	dec->GotoBegin800x = (u32)(0xFFFF / dec->K1);
	
	ra -> Speed_1x  = (u32)(620 * ra->K2);
	dec -> Speed_1x = (u32)(620 * dec->K2);
	
	ra -> Speed  = ra -> Speed_1x;
	dec -> Speed = dec -> Speed_1x;
	
	ra->Mode  = 1;
	dec->Mode = 1;
}

void initSpeedRA (struct RegisterAxis *axis){
	if(axis->Enable) EN_RA_DW;
	switch (axis->Mode){
	case 0: case 1: {DIR_RA_UP; TIM17->PSC = 160 - 1; TIM17->ARR = axis->Speed; break;}
	case 2: case 3: {DIR_RA_DW; TIM17->PSC = 160 - 1; TIM17->ARR = axis->Speed; break;}
	case 4: case 5: {DIR_RA_UP; TIM17->ARR = axis->Speed; break;}
	case 6: case 7: {DIR_RA_DW; TIM17->ARR = axis->Speed; break;}
	}
}

void initSpeedDEC (struct RegisterAxis *axis){
	if(axis->Enable) EN_DEC_DW;
	switch (axis->Mode){
	case 0: case 1: {DIR_DEC_UP; TIM16->PSC = 160 - 1; TIM16->ARR = axis->Speed; break;}
	case 2: case 3: {DIR_DEC_DW; TIM16->PSC = 160 - 1; TIM16->ARR = axis->Speed; break;}
	case 4: case 5: {DIR_DEC_UP; TIM16->ARR = axis->Speed; break;}
	case 6: case 7: {DIR_DEC_DW; TIM16->ARR = axis->Speed; break;}
	}
}

void encoderGoto (struct RegisterAxis *axis){
	switch (axis->Mode){
	case 1: case 5: {axis->Encoder += 100; break;}
	case 3: case 7: {axis->Encoder -= 100; break;}
	case 0: {
		axis->Encoder += 100;
		if (axis->Encoder >= axis->Goto) {axis->ControlON = 0; axis->StatusGoto = 0;}
		break;
	}
	case 2: {
		axis->Encoder -= 100;
		if (axis->Encoder <= axis->Goto) {axis->ControlON = 0; axis->StatusGoto = 0;}
		break;
	}
	case 4: {
		axis->Encoder += 100;
		if (axis->Encoder >= (axis->Goto - axis->BeginBraking)) {axis->ControlON = 0; axis->StatusGoto = 0;}
		break;
	}
	case 6: {
		axis->Encoder -= 100;
		if (axis->Encoder <= (axis->Goto + axis->BeginBraking)) {axis->ControlON = 0; axis->StatusGoto = 0;}
	}
	}
}

void slowStartStop(struct RegisterAxis *axis, u16 volatile *Timer){
	
	if (axis->ControlON){
		switch (axis->Mode){
		case 0: case 2: axis->StatusGoto = 1;
		case 1: case 3: {axis->StatusON = 1; break;}
		case 4: case 6: axis->StatusGoto = 1;
		case 5: case 7: {
			axis->StatusON = 1;
			if(((*Timer) > 10-1) && (axis->temp32 <= SysTickTime)){
				(*Timer)--;
				axis->temp32 = SysTickTime + 10;
			}
			break;
			
		}
		}
	}
	else {
		switch (axis->Mode){
		case 0: case 1: case 2: case 3: {axis->StatusON = 0; break;}
		case 5: case 7: {
			if((*Timer) < 160-1){
			   if(axis->temp32 <= SysTickTime){
				(*Timer)++;
				axis->temp32 = SysTickTime + 10;
			   }
			}
			else {axis->StatusON = 0;}
			break;
		}
		case 4: {
			if((*Timer) < 160-1){
			   if(axis->temp32 <= SysTickTime){
				(*Timer)++;
				axis->temp32 = SysTickTime + 10;
			   }
			} 
			else {
				if(!axis->StatusGoto && axis->StatusON) {axis->ControlON = 1; axis->Mode = 0;}
				else {axis->StatusON = 0; axis->Mode = 1; axis->StatusGoto = 0;}
			}
			break;
		}
		case 6: {
			if((*Timer) < 160-1){
			   if(axis->temp32 <= SysTickTime){
				(*Timer)++;
				axis->temp32 = SysTickTime + 10;
			   }
			} 
			else {
				if(!axis->StatusGoto && axis->StatusON) {axis->ControlON = 1; axis->Mode = 2;}
				else {axis->StatusON = 0; axis->Mode = 3; axis->StatusGoto = 0;}
			}
			break;
		}
		}
	}
}
