/*******************************************************************************
********************************************************************************

	File	: main.c
	Project	: EQDRIVE
	Version	: 0.100
	Date	: 26.10.2011
	Author	: Ruslan Korop                           
	Company	: Home                            

MCU: STM32F100PB, board - STM32DISCOVERY.
Clock frequency	: 24,000000 MHz

********************************************************************************
*******************************************************************************/

#include    "main.h"

#define		BEGIN	':'
#define		END		'\r'

#define     LED3_ON		GPIO_BSRR_BS9
#define     LED3		GPIO_ODR_ODR9
#define     LED4		GPIO_ODR_ODR8
#define     LED3_OF		GPIO_BSRR_BR9
#define     LED4_ON		GPIO_BSRR_BS8
#define     LED4_OF		GPIO_BSRR_BR8

#define	REF_RA_UP		GPIOB->BSRR=GPIO_BSRR_BS12
#define	REF_RA_DW		GPIOB->BSRR=GPIO_BSRR_BR12
#define	STEP_RA_UP		GPIOB->BSRR=GPIO_BSRR_BS13
#define	STEP_RA_DW		GPIOB->BSRR=GPIO_BSRR_BR13
#define	DIR_RA_UP		GPIOB->BSRR=GPIO_BSRR_BS14
#define	DIR_RA_DW		GPIOB->BSRR=GPIO_BSRR_BR14
#define	EN_RA_UP		GPIOB->BSRR=GPIO_BSRR_BS15
#define	EN_RA_DW		GPIOB->BSRR=GPIO_BSRR_BR15

#define	REF_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS8
#define	REF_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR8
#define	STEP_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS9
#define	STEP_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR9
#define	DIR_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS10
#define	DIR_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR10
#define	EN_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS11
#define	EN_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR11

//Global varieble
u32 SysTickTime;
u32 TimeHL, TimeOut;
u16 temp16;
u8 temp8;
u8 FlagStepRA, FlagStepDEC, FlagRxEnd, FlagResetTimeOut, RxCounter, Flag1;
u8 RxBuffer[10], s[6];
/*
struct {
	unsigned StepRA:1;
	unsigned StepDEC:1;
	unsigned RxEnd:1;
} Flag;
*/
struct RegisterAxis RA, DEC;


int main(void){
u16 i;
	
	//RA.Speed = 620;
	RA.Speed = 5729;
	RA.ControlMODE = 1;
	RA.StatusMODE = 1;
	//RA.StatusEN=1;
	//DEC.StatusEN=1;
	DEC.ControlMODE = 1;
	DEC.StatusMODE = 1;
	
	init_clock();
	init_peripherals();
	//SysTick_Config(2400000);
	
	printf ("Hello, my name is EQDRIVE\r");
	
	GPIOC->BSRR=LED4_ON; //  LED4
	GPIOC->BSRR=LED4_OF; //  LED4
	GPIOC->BSRR=LED4_ON; //  LED4
	
	EN_RA_DW;
	REF_RA_UP;
	DIR_RA_UP;
	
    while(1){
		ADC1->CR2 |= ADC_CR2_SWSTART;
		while ((ADC1->SR & ADC_SR_EOC) != ADC_SR_EOC);
		temp16 = ADC1->DR;
		if (temp16 > 0x7FF) GPIOC->BSRR=LED4_ON;
		else GPIOC->BSRR=LED4_OF;
            //   ,  ,  .
            // if    ((GPIOA->IDR & GPIO_IDR_IDR0)) {GPIOC->BSRR = LED3_ON|LED4_ON;}
            // else  { GPIOC->BSRR = LED3_OF|LED4_OF;}
		
		if (FlagStepRA || Flag1){
			Flag1 = 0;
		  //STEP_RA_UP;
			i=5;
			while(i--);
			STEP_RA_DW;
			FlagStepRA =0;
			switch (RA.StatusMODE){
			case 1: {RA.Encoder++; break;}
			case 3: {RA.Encoder--; break;}
			case 5: {
				RA.Encoder++;
				if (RA.ControlON){
					RA.StatusON=1;
					if((TIM17->PSC > 10) && (TimeHL <= SysTickTime)){
						TIM17->PSC--;
						TimeHL = SysTickTime + 10;
					}
				}
				else{
					if(TIM17->PSC < 159){
						if(TimeHL <= SysTickTime){
							TIM17->PSC++;
							TimeHL = SysTickTime + 10;
						}
					}
					else RA.StatusON = 0;
				}
				break;
			}
			case 7: {
				RA.Encoder--;
				if (RA.ControlON){
					RA.StatusON=1;
					if((TIM17->PSC > 10) && (TimeHL <= SysTickTime)){
						TIM17->PSC--;
						TimeHL = SysTickTime + 10;
					}
				}
				else{
					if(TIM17->PSC < 159){
						if(TimeHL <= SysTickTime){
							TIM17->PSC++;
							TimeHL = SysTickTime + 10;
						}
					}
					else RA.StatusON = 0;
				}
				break;
			}
			}
		}
		
		if (FlagRxEnd){
			if(!(eqmod(RxBuffer, &RA, &DEC)))
			{
				RA.StatusMODE = RA.ControlMODE;
				//RA.StatusON = RA.ControlON;
				RA.StatusEN = RA.ControlEN;
				//TIM17->ARR = RA.Speed * 4;
				TIM17->ARR = RA.Speed;
				
				switch (RA.StatusMODE){
				case 1: {DIR_RA_UP; TIM17->PSC = 160 - 1; RA.StatusON = RA.ControlON; break;}
				case 3: {DIR_RA_DW; TIM17->PSC = 160 - 1; RA.StatusON = RA.ControlON; break;}
				case 5: {DIR_RA_UP; break;} // TIM17->PSC = 10 - 1; break;}
				case 7: {DIR_RA_DW; break;} // TIM17->PSC = 10 - 1; break;}
				}
				
			}
			DEC.StatusMODE = DEC.ControlMODE;
			DEC.StatusON = DEC.ControlON;
			DEC.StatusEN = DEC.ControlEN;
			Flag1 = 1;
			FlagRxEnd =0;
		}
		
		if (RxCounter){ //  USART1
			if(FlagResetTimeOut){
				FlagResetTimeOut = 0;
				TimeOut = SysTickTime + 10000; // Timeout = 10 c.
			}
			if(TimeOut <= SysTickTime) RxCounter = 0;
		}
	}
}

void SysTick_Handler (void){
	SysTickTime++;
}

void EXTI0_IRQHandler (void){
    GPIOC->ODR ^= LED3;
    EXTI->PR = EXTI_PR_PR0;
    NVIC_ClearPendingIRQ (EXTI0_IRQn);
}

void TIM1_UP_TIM16_IRQHandler (void){
    //GPIOC->ODR ^= LED3;
	if (RA.StatusON) {STEP_DEC_UP; FlagStepDEC = 1;}
    TIM16->SR &= ~TIM_SR_UIF;
    //NVIC_ClearPendingIRQ (TIM1_UP_TIM16_IRQn);
	STEP_DEC_DW;
}

void TIM1_TRG_COM_TIM17_IRQHandler (void){
	GPIOC->ODR ^= LED3;
	if (RA.StatusON) {STEP_RA_UP; FlagStepRA =1;}
    TIM17->SR &= ~TIM_SR_UIF;
    //NVIC_ClearPendingIRQ (TIM1_TRG_COM_TIM17_IRQn);
	STEP_RA_DW;
}

void USART1_IRQHandler (void){ //    USART1
u32 UsartData, UsartState;

	UsartState = USART1->SR;
	UsartData  = USART1->DR; //    SR  DR 
	if (UsartState & USART_SR_RXNE){ //    
		if (!(UsartState & 0x0007)){ //    
			FlagResetTimeOut = 1; //  
			if (!RxCounter){ //    
				if (UsartData == BEGIN) RxCounter++;
			}
			else{
				if (UsartData == END){ //    
					RxBuffer[0] = RxCounter - 1;
					RxCounter = 0;
					FlagRxEnd = 1;
				}
				else{
					RxBuffer[RxCounter] = UsartData;
					RxCounter++;
				}
			}
		}
	}
}
